Cabal-2.0.1.0: A framework for packaging Haskell software

Safe Haskell | None
Language | Haskell2010

Distribution.Types.MungedPackageId

Synopsis

- data MungedPackageId = MungedPackageId {
  - mungedName :: MungedPackageName
  - mungedVersion :: Version
  }
- computeCompatPackageId :: PackageId -> Maybe UnqualComponentName -> MungedPackageId

# Documentation

data MungedPackageId #

A simple pair of a `MungedPackageName` and `Version`. `MungedPackageName` is to `MungedPackageId` as `PackageName` is to `PackageId`. See `MungedPackageName` for more info.

Constructors

MungedPackageId |

Fields

- mungedName :: MungedPackageName

  The combined package and component name. see documentation for `MungedPackageName`.

- mungedVersion :: Version

  The version of this package / component, eg 1.2

Instances

Eq MungedPackageId # |
Methods (==) :: MungedPackageId -> MungedPackageId -> Bool # (/=) :: MungedPackageId -> MungedPackageId -> Bool #
Data MungedPackageId # |

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> MungedPackageId -> c MungedPackageId Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c MungedPackageId Source #

toConstr :: MungedPackageId -> Constr Source #

dataTypeOf :: MungedPackageId -> DataType Source #

dataCast1 :: Typeable (* -> *) t => (forall d. Data d => c (t d)) -> Maybe (c MungedPackageId) Source #

dataCast2 :: Typeable (* -> * -> *) t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c MungedPackageId) Source #

gmapT :: (forall b. Data b => b -> b) -> MungedPackageId -> MungedPackageId Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> MungedPackageId -> r Source #

gmapQr :: (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> MungedPackageId -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> MungedPackageId -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> MungedPackageId -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> MungedPackageId -> m MungedPackageId Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> MungedPackageId -> m MungedPackageId Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> MungedPackageId -> m MungedPackageId Source #

Ord MungedPackageId # |

Methods

compare :: MungedPackageId -> MungedPackageId -> Ordering #

(<) :: MungedPackageId -> MungedPackageId -> Bool #

(<=) :: MungedPackageId -> MungedPackageId -> Bool #

(>) :: MungedPackageId -> MungedPackageId -> Bool #

(>=) :: MungedPackageId -> MungedPackageId -> Bool #

max :: MungedPackageId -> MungedPackageId -> MungedPackageId #

min :: MungedPackageId -> MungedPackageId -> MungedPackageId #

Read MungedPackageId # |
Methods readsPrec :: Int -> ReadS MungedPackageId Source # readList :: ReadS [MungedPackageId] Source # readPrec :: ReadPrec MungedPackageId Source # readListPrec :: ReadPrec [MungedPackageId] Source #
Show MungedPackageId # |
Methods showsPrec :: Int -> MungedPackageId -> ShowS Source # show :: MungedPackageId -> String Source # showList :: [MungedPackageId] -> ShowS Source #
Generic MungedPackageId # |
Associated Types type Rep MungedPackageId :: * -> * Source # Methods from :: MungedPackageId -> Rep MungedPackageId x Source # to :: Rep MungedPackageId x -> MungedPackageId Source #
NFData MungedPackageId # |
Methods rnf :: MungedPackageId -> () Source #
Binary MungedPackageId # |
Methods put :: MungedPackageId -> Put Source # get :: Get MungedPackageId Source # putList :: [MungedPackageId] -> Put Source #
Text MungedPackageId # |
Methods disp :: MungedPackageId -> Doc # parse :: ReadP r MungedPackageId #
HasMungedPackageId MungedPackageId # |
Methods mungedId :: MungedPackageId -> MungedPackageId #
type Rep MungedPackageId # |

type Rep MungedPackageId = D1 * (MetaData "MungedPackageId" "Distribution.Types.MungedPackageId" "Cabal-2.0.1.0" False) (C1 * (MetaCons "MungedPackageId" PrefixI True) ((:*:) * (S1 * (MetaSel (Just Symbol "mungedName") NoSourceUnpackedness NoSourceStrictness DecidedLazy) (Rec0 * MungedPackageName)) (S1 * (MetaSel (Just Symbol "mungedVersion") NoSourceUnpackedness NoSourceStrictness DecidedLazy) (Rec0 * Version))))

computeCompatPackageId :: PackageId -> Maybe UnqualComponentName -> MungedPackageId #

See docs for `computeCompatPackageId`. this is a thin wrapper around that.